<template>
  <q-page class="flex-center">
    <q-card>
      <q-card-section>
        <q-bar class="bg-white">
          <q-btn dense push icon="next_plan" @click="backPage">
            Back Page
            <q-tooltip>Back Page</q-tooltip>
          </q-btn>
        </q-bar>
      </q-card-section>
      <hr />
      <q-table
        :rows-per-page-options="[15, 25, 50]"
        :data="data"
        :columns="columns"
        :loading="loading"
        separator="cell"
        @request="onRequest"
        :pagination.sync="pagination"
        row-key="id"
      >
        <template slot="top" slot-scope="props">
          <div class="text-h6">Company {{ form.name }}</div>
          <div class="col" />
          <q-btn push rounded color="primary" icon="add" @click="add()"
            >Add Downline</q-btn
          >
          <!-- <q-btn push rounded color="primary" icon="add" @click="add()" >Loadong...</q-btn>             -->
        </template>
        <q-tr slot="body" slot-scope="props" :props="props">
          <q-td
            key="No"
            :props="props"
            :style="{ width: '20px', whiteSpace: 'normal' }"
            >{{ props.row.No }}</q-td
          >
          <q-td
            key="role"
            :props="props"
            :style="{ width: '100px', whiteSpace: 'normal' }"
            >{{ props.row.role_name }}
          </q-td>
          <q-td
            key="owner"
            :props="props"
            :style="{ width: '100px', whiteSpace: 'normal' }"
            >{{ props.row.parent_name }}
          </q-td>
          <q-td
            key="name"
            :props="props"
            :style="{ width: '200px', whiteSpace: 'normal' }"
            >{{ props.row.name }}</q-td
          >
          <q-td
            key="username"
            :props="props"
            :style="{
              width: '100px',
              whiteSpace: 'normal',
              'text-align': 'center'
            }"
          >
            <q-badge color="white" text-color="black">
              {{ props.row.username }}
              <!-- <q-icon
                name="warning"
                size="14px"
                class="q-ml-xs"
              ></q-icon> -->
            </q-badge>

            <q-btn
              dense
              color="red"
              icon="lock"
              size="sm"
              @click="open_pass(props.row)"
            >
              <span class="material-icons"></span>
              <q-tooltip
                anchor="center right"
                self="center left"
                :offset="[5, 5]"
              >
                <strong>Reset Password</strong>
              </q-tooltip>
            </q-btn>
          </q-td>
          <q-td
            key="credit"
            :props="props"
            :style="{ width: '100px', whiteSpace: 'normal' }"
          >
            {{ props.row.credit | toUSD }}
          </q-td>
          <q-td
            key="log"
            :props="props"
            :style="{ width: '100px', whiteSpace: 'normal' }"
          >
            <div
              class="row justify-between no-wrap"
              v-if="props.row.level == 6"
            >
              <q-btn
                rounded
                dense
                color="primary"
                size="xs"
                icon="add"
                @click="open_deposit(props.row)"
              />
              <q-btn
                rounded
                dense
                color="primary"
                size="xs"
                icon="remove"
                @click="open_withdraw(props.row)"
              />
              <q-btn
                rounded
                dense
                color="primary"
                size="xs"
                icon="assignment"
              />
            </div>
          </q-td>
          <q-td
            key="phone"
            :props="props"
            :style="{ width: '100px', whiteSpace: 'normal' }"
            >{{ props.row.phone }}</q-td
          >
          <q-td
            key="status"
            :props="props"
            :style="{ width: '20px', whiteSpace: 'normal' }"
          >
            <q-toggle
              v-model="props.row.status"
              :false-value="0"
              :true-value="1"
              :disable="props.row.level == '2'"
              @input="ChangeStatus(props.row)"
            ></q-toggle>
          </q-td>
          <q-td
            key="action"
            :props="props"
            :style="{ width: '20px', whiteSpace: 'normal' }"
          >
            <div class="row items-center justify-between no-wrap">
              <q-btn
                size="sm"
                round
                rounded
                color="secondary"
                icon="settings"
                @click="load(props.row)"
                class="q-mr-xs"
                :disable="props.row.level == 2"
              />
            </div>
          </q-td>
        </q-tr>

        <template v-slot:top-row>
          <q-tr>
            <q-td></q-td>
            <q-td colspan="2">
              <q-select
                dense
                debounce="300"
                outlined
                label="Select Role"
                v-model="filter.role"
                :options="role_options"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
                @input="getdata"
              />
            </q-td>

            <q-td>
              <q-input
                dense
                debounce="300"
                outlined
                v-model="filter.name"
                label="Filter Name"
                @input="getdata"
              ></q-input>
            </q-td>
            <q-td colspan="2">
              <q-input
                dense
                debounce="300"
                outlined
                v-model="filter.user"
                label="Filter Username"
                @input="getdata"
              ></q-input>
            </q-td>
            <td></td>
            <q-td>
              <q-input
                dense
                debounce="300"
                outlined
                v-model="filter.phone"
                label="Filter Phone"
                @input="getdata"
              ></q-input>
            </q-td>
            <q-td>
              <q-select
                dense
                debounce="300"
                outlined
                label="Select Status"
                v-model="filter.status"
                :options="options"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
                @input="getdata"
              />
            </q-td>
            <q-td></q-td>
          </q-tr>
        </template>
      </q-table>
    </q-card>
    <!-- add game -->
    <q-dialog
      full-width
      full-height
      v-model="modal_add"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card>
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form_member"
            ref="form_member"
            :rules="rules_member"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Role" prop="role">
              <q-select
                filled
                v-model="form_member.role"
                :options="role_options"
                @input="roleChange"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
              />
            </el-form-item>
            <el-form-item label="Owner" prop="owner">
              <q-select
                filled
                v-model="form_member.owner"
                :options="member_options"
                @input="ownerChange"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
                :disable="disable"
              />
            </el-form-item>
            <el-form-item label="Name" prop="name">
              <el-input
                v-model="form_member.name"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Credit" prop="credit">
              <currency-input
                v-model="form_member.credit"
                currency="THB"
                @change="check_credit"
              />
            </el-form-item>
            <el-form-item label="Username" prop="username">
              <el-input
                v-model="form_member.username"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Password" prop="password">
              <el-input
                v-model="form_member.password"
                type="password"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Confrim" prop="confrim">
              <el-input
                type="password"
                v-model="form_member.confrim"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Phone" prop="phone">
              <el-input
                v-model="form_member.phone"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Domain" prop="domain" v-show="domain">
              <el-input
                v-model="form_member.domain"
                autocomplete="off"
              ></el-input>
            </el-form-item>
          </el-form>
          <hr />
          <q-table
            :rows-per-page-options="[15, 25, 50]"
            :data="provider"
            :columns="game_columns"
            separator="cell"
            row-key="id"
            virtual-scroll
            :pagination.sync="pagination_provider"
          >
            <q-tr slot="header" slot-scope="props" :props="props">
              <q-th key="status_" :props="props">
                <q-checkbox
                  keep-color
                  v-model="checkall"
                  color="green"
                  @input="onSelection"
                />
              </q-th>
              <q-th key="name" :props="props">Name</q-th>
              <q-th key="percent" :props="props">
                <div class="row">
                  <div class="col-12">Percent</div>
                  <div class="col-12">
                    <el-input-number
                      v-if="checkall == 1 && 6 > role"
                      v-model="percent_"
                      controls-position="right"
                      :min="0"
                      :max="100"
                      @change="syncpercent"
                    ></el-input-number>
                  </div>
                </div>
              </q-th>
              <q-th key="commission" :props="props">
                <div class="row">
                  <div class="col-12">Commission</div>
                  <div class="col-12">
                    <el-input-number
                      v-if="checkall == 1 && 6 > role"
                      v-model="commission_"
                      controls-position="right"
                      :min="0"
                      :max="10"
                      @change="synccommison"
                    ></el-input-number>
                  </div>
                </div>
              </q-th>
            </q-tr>
            <q-tr slot="body" slot-scope="props" :props="props">
              <q-td
                key="status_"
                :props="props"
                :style="{ width: '50px', whiteSpace: 'normal' }"
              >
                <q-checkbox
                  keep-color
                  v-model="props.row.status_"
                  color="green"
                  @input="rowSelect"
                />
              </q-td>
              <q-td
                key="name"
                :props="props"
                :style="{ width: '200px', whiteSpace: 'normal' }"
                >{{ props.row.name }}
              </q-td>
              <q-td
                key="percent"
                :props="props"
                :style="{ width: '200px', whiteSpace: 'normal' }"
              >
                <template>
                  <el-input-number
                    v-if="props.row.status_ == 1 && 6 > role"
                    v-model="props.row.percent_"
                    controls-position="right"
                    :min="0"
                    :max="props.row.percent"
                  ></el-input-number>
                </template>
              </q-td>
              <q-td
                key="commission"
                :props="props"
                :style="{ width: '200px', whiteSpace: 'normal' }"
              >
                <template>
                  <el-input-number
                    v-if="props.row.status_ == 1 && 6 > role"
                    v-model="props.row.commission_"
                    controls-position="right"
                    :min="0"
                    :max="props.row.commission"
                  ></el-input-number>
                </template>
              </q-td>
            </q-tr>
          </q-table>
        </q-card-section>
        <q-card-actions align="right">
          <q-btn push rounded color="primary" @click="insert()">Submit</q-btn>
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>

    <!-- update game -->
    <q-dialog
      full-width
      full-height
      v-model="modal_edit"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card>
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form_member_edit"
            ref="form_member_edit"
            :rules="rules_member_edit"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Role" prop="role">
              <q-select
                filled
                v-model="form_member_edit.role"
                :options="role_options"
                @input="roleChange"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
              />
            </el-form-item>
            <el-form-item label="Owner" prop="owner">
              <q-select
                filled
                v-model="form_member_edit.owner"
                :options="member_options"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
              />
            </el-form-item>
            <el-form-item label="Name" prop="name">
              <el-input
                v-model="form_member_edit.name"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Credit" prop="credit">
              <currency-input
                v-model="form_member_edit.credit"
                currency="THB"
                @change="check_credit_update"
              />
            </el-form-item>
            <el-form-item label="Username" prop="username">
              <el-input
                v-model="form_member_edit.username"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Phone" prop="phone">
              <el-input
                v-model="form_member_edit.phone"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Domain" prop="domain" v-show="domain">
              <el-input
                v-model="form_member_edit.domain"
                autocomplete="off"
              ></el-input>
            </el-form-item>
          </el-form>
          <hr />
          <q-table
            :rows-per-page-options="[15, 25, 50]"
            :data="provider"
            :columns="game_columns"
            separator="cell"
            row-key="id"
            virtual-scroll
            :pagination.sync="pagination_provider"
          >
            <q-tr slot="header" slot-scope="props" :props="props">
              <q-th key="status_" :props="props">
                <q-checkbox
                  keep-color
                  v-model="checkall"
                  color="green"
                  @input="onSelection"
                />
              </q-th>
              <q-th key="name" :props="props">Name</q-th>
              <q-th key="percent" :props="props">
                <div class="row">
                  <div class="col-12">Percent</div>
                  <div class="col-12">
                    <el-input-number
                      v-if="checkall == 1 && 6 > role"
                      v-model="percent_"
                      controls-position="right"
                      :min="0"
                      :max="100"
                      @change="syncpercent"
                    ></el-input-number>
                  </div>
                </div>
              </q-th>
              <q-th key="commission" :props="props">
                <div class="row">
                  <div class="col-12">Commission</div>
                  <div class="col-12">
                    <el-input-number
                      v-if="checkall == 1 && 6 > role"
                      v-model="commission_"
                      controls-position="right"
                      :min="0"
                      :max="10"
                      @change="synccommison"
                    ></el-input-number>
                  </div>
                </div>
              </q-th>
            </q-tr>
            <q-tr slot="body" slot-scope="props" :props="props">
              <q-td
                key="status_"
                :props="props"
                :style="{ width: '50px', whiteSpace: 'normal' }"
              >
                <q-checkbox
                  keep-color
                  v-model="props.row.status_"
                  color="green"
                  @input="rowSelect"
                />
              </q-td>
              <q-td
                key="name"
                :props="props"
                :style="{ width: '200px', whiteSpace: 'normal' }"
                >{{ props.row.name }}
              </q-td>
              <q-td
                key="percent"
                :props="props"
                :style="{ width: '200px', whiteSpace: 'normal' }"
              >
                <template>
                  <el-input-number
                    v-if="props.row.status_ == 1 && 6 > role"
                    v-model="props.row.percent_"
                    controls-position="right"
                    :min="0"
                    :max="props.row.percent"
                  ></el-input-number>
                </template>
              </q-td>
              <q-td
                key="commission"
                :props="props"
                :style="{ width: '200px', whiteSpace: 'normal' }"
              >
                <template>
                  <el-input-number
                    v-if="props.row.status_ == 1 && 6 > role"
                    v-model="props.row.commission_"
                    controls-position="right"
                    :min="0"
                    :max="props.row.commission"
                  ></el-input-number>
                </template>
              </q-td>
            </q-tr>
          </q-table>
        </q-card-section>
        <q-card-actions align="right">
          <q-btn push rounded color="primary" @click="Update()">Submit</q-btn>
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>

    <!-- deposit -->
    <q-dialog
      v-model="modal_deposit"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card style="width: 700px; max-width: 80vw;">
        <q-bar>
          <div class="text-h6">+ ฝากเงิน</div>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form_deposit"
            ref="form_deposit"
            :rules="rules_deposit"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Amount" prop="amount">
              <currency-input v-model="form_deposit.amount" currency="THB" />
            </el-form-item>
          </el-form>
        </q-card-section>
        <q-card-actions align="right" class="bg-primary text-white">
          <q-btn push rounded color="primary" @click="deposit()">Submit</q-btn>
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>

    <!-- withdraw -->
    <q-dialog
      v-model="modal_withdraw"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card style="width: 700px; max-width: 80vw;">
        <q-bar>
          <div class="text-h6">+ ถอนเงิน</div>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form_withdraw"
            ref="form_withdraw"
            :rules="rules_deposit"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Amount" prop="amount">
              <currency-input v-model="form_withdraw.amount" currency="THB" />
            </el-form-item>
          </el-form>
        </q-card-section>
        <q-card-actions align="right" class="bg-primary text-white">
          <q-btn push rounded color="primary" @click="withdraw()">Submit</q-btn>
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>

    <!-- reset password -->
    <q-dialog
      v-model="modal_reset"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card style="width: 700px; max-width: 80vw;">
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form_reset"
            ref="form_reset"
            :rules="rules_reset"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Old Password" prop="old_password">
              <el-input
                type="password"
                v-model="form_reset.old_password"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="New Password" prop="new_password">
              <el-input
                type="password"
                v-model="form_reset.new_password"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Confrim" prop="confrim">
              <el-input
                type="password"
                v-model="form_reset.confrim"
                autocomplete="off"
              ></el-input>
            </el-form-item>
          </el-form>
        </q-card-section>
        <q-card-actions align="right" class="bg-primary text-white">
          <q-btn push rounded color="primary" @click="reset_pass()"
            >Submit</q-btn
          >
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>
  </q-page>
</template>

<script>
import { QSpinnerGears } from "quasar";

export default {
  name: "CompanyDetail",
  data() {
    var validatePass = (rule, value, callback) => {
      if (value === "") {
        callback(new Error("Please input the password"));
      } else {
        if (this.form_member.confrim !== "") {
          this.$refs.form_member.validateField("confrim");
        }
        callback();
      }
    };
    var validatePass2 = (rule, value, callback) => {
      if (value === "") {
        callback(new Error("Please input the password again"));
      } else if (value !== this.form_member.password) {
        callback(new Error("Two inputs don't match!"));
      } else {
        callback();
      }
    };

    var validateReset = (rule, value, callback) => {
      if (value === "") {
        callback(new Error("Please input the password"));
      } else {
        if (this.form_reset.confrim !== "") {
          this.$refs.form_reset.validateField("confrim");
        }
        callback();
      }
    };
    var validateReset2 = (rule, value, callback) => {
      if (value === "") {
        callback(new Error("Please input the password again"));
      } else if (value !== this.form_reset.new_password) {
        callback(new Error("Two inputs don't match!"));
      } else {
        callback();
      }
    };
    return {
      data: [],
      search: "",
      modal_add: false,
      modal_edit: false,
      domain: false,
      type_options: [],
      options: [
        { value: 1, label: "Enable" },
        { value: 0, label: "Disable" }
      ],
      btn: [
        { label: "Disable", color: "red" },
        { label: "Enable", color: "primary" }
      ],
      role_options: [],
      member_options: [],
      columns: [
        {
          name: "No",
          label: "No",
          field: "No",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "role",
          label: "Role",
          field: "role",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "owner",
          label: "UPLINE USERNAME",
          field: "owner",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "name",
          label: "Name",
          field: "name",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "username",
          label: "Username",
          field: "username",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "credit",
          label: "Credit",
          field: "credit",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "log",
          label: "Log",
          field: "id",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "phone",
          label: "Phone",
          field: "phone",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "status",
          label: "Status",
          field: "status",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "action",
          label: "Action",
          field: "id",
          require: true,
          align: "left",
          stortable: true
        }
      ],
      game_columns: [
        {
          name: "status_",
          label: "Status",
          field: "status_",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "name",
          label: "Name",
          field: "name",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "percent",
          label: "Percent",
          field: "percent",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "commission",
          label: "Commission",
          field: "commission",
          require: true,
          align: "left",
          stortable: true
        }
      ],
      separator: "horizontal",
      pagination: {
        sortBy: "desc",
        descending: false,
        page: 1,
        rowsPerPage: 10,
        rowsNumber: 10
      },
      pagination_provider: {
        rowsPerPage: 0
      },
      form: {},
      form_member: {
        role: "",
        owner: "",
        name: "",
        credit: null,
        username: "",
        password: "",
        confrim: "",
        status: null,
        company: "",
        game_member: [],
        domain: "",
        parent: ""
      },
      form_member_edit: {},
      rules_member: {
        name: [
          { required: true, message: "Please input name", trigger: "blur" }
        ],
        role: [
          { required: true, message: "Please select status", trigger: "change" }
        ],
        owner: [
          { required: true, message: "Please select owner", trigger: "change" }
        ],
        credit: [
          { required: true, message: "Please input credit", trigger: "blur" }
        ],
        username: [
          { required: true, message: "Please input username", trigger: "blur" }
        ],
        password: [
          { required: true, validator: validatePass, trigger: "blur" }
        ],
        confrim: [
          { required: true, validator: validatePass2, trigger: "blur" }
        ],
        phone: [
          { required: true, message: "Please input phone", trigger: "blur" }
        ]
      },

      rules_member_edit: {
        name: [
          { required: true, message: "Please input name", trigger: "blur" }
        ],
        role: [
          { required: true, message: "Please select status", trigger: "change" }
        ],
        owner: [
          { required: true, message: "Please select owner", trigger: "change" }
        ],
        credit: [
          { required: true, message: "Please input credit", trigger: "blur" }
        ],
        phone: [
          { required: true, message: "Please input phone", trigger: "blur" }
        ]
        // domain: [{required: true, message: 'Please input domain', trigger: 'blur'}]
      },
      disable: true,
      show: true,
      credit_remain: 0,
      role: "",
      provider: [],
      checkall: false,
      commission_: 0,
      percent_: 0,
      commission: 0,
      percent: 0,
      selected: [],
      filter: {},
      loading: false,
      owner_filter: [],
      modal_deposit: false,
      modal_withdraw: false,
      form_deposit: {},
      form_withdraw: {},
      rules_deposit: {
        amount: [
          { required: true, message: "Please input amount", trigger: "blur" }
        ]
      },

      form_reset: {
        old_password: "",
        new_password: "",
        confrim: ""
      },
      rules_reset: {
        old_password: [
          {
            required: true,
            message: "Please input Old password",
            trigger: "blur"
          }
        ],
        new_password: [
          { required: true, validator: validateReset, trigger: "blur" }
        ],
        confrim: [
          { required: true, validator: validateReset2, trigger: "blur" }
        ]
      },
      modal_reset: false
    };
  },

  async created() {
    await this.getcompany();
    // // await this.gettypegame()
    await this.getrole();
    await this.getdata();
    await this.get_owner();
  },

  methods: {
    async onRequest(props) {
      this.$q.loading.show({
        spinner: QSpinnerGears,
        spinnerColor: "primary",
        message: "loading......"
      });
      try {
        this.loading = true;
        const { page, rowsPerPage, sortBy, descending } = props.pagination;
        this.filter.page_limit = rowsPerPage;
        this.filter.page = page;
        this.filter.company = this.$route.params.id;
        if (this.filter.name == "") {
          delete this.filter.name;
        }

        if (this.filter.user == "") {
          delete this.filter.user;
        }

        if (this.filter.phone == "") {
          delete this.filter.phone;
        }

        if (this.filter.status == 3) {
          delete this.filter.status;
        }
        let result = await this.$services.member.readByCompany(this.filter);
        this.pagination.rowsNumber = result.total;
        const fetchCount =
          rowsPerPage === 0 ? this.pagination.rowsNumber : rowsPerPage;
        const startRow = (page - 1) * rowsPerPage;
        this.data = result.results;
        this.$services.updateindex(this.data);
        this.pagination.page = page;
        this.pagination.rowsPerPage = rowsPerPage;
        this.pagination.sortBy = sortBy;
        this.pagination.descending = descending;
        this.loading = false;
        this.$q.loading.hide();
      } catch (e) {
        this.$services.error(e.response, this.$route);
      }
    },

    async getdata() {
      this.onRequest({
        pagination: this.pagination
      });
    },

    async getcompany(pageNumber) {
      try {
        this.form = await this.$services.company.find_by_id(
          this.$route.params.id
        );
      } catch (e) {
        this.$services.error(e.response, this.$route);
      }
    },

    async get_subscribe(id) {
      try {
        this.provider = await this.$services.subscribe.read(id);
        this.percent = Math.max.apply(
          Math,
          this.provider.map(function(obj) {
            return obj.percent;
          })
        );
        this.commission = Math.max.apply(
          Math,
          this.provider.map(function(obj) {
            return obj.commission;
          })
        );
      } catch (e) {
        this.$services.error(e.response, this.$route);
      }
    },

    async getrole() {
      let ctx = this;
      this.role_options = [];
      this.$services.role
        .read()
        .then(function(data) {
          data.forEach(row => {
            if (row.level > 2) {
              ctx.role_options.push({
                value: row.id,
                label: row.name,
                level: row.level
              });
            }
          });
        })
        .catch(function(e) {
          ctx.$services.error(e.response, ctx.$route);
        });
    },

    optionOwner(level) {
      this.member_options = [];
      this.data.forEach(row => {
        if (level == 6) {
          if (row.level == 5 || row.level == 4) {
            this.member_options.push({ value: row.id, label: row.name });
          }
        } else {
          if (row.level == level - 1) {
            this.member_options.push({ value: row.id, label: row.name });
          }
        }
      });
    },

    add() {
      this.modal_add = true;
      this.domain = false;
      this.type_options = [];
      this.form_member = {
        role: "",
        owner: "",
        name: "",
        credit: null,
        username: "",
        password: "",
        confrim: "",
        status: null,
        company: this.form.id,
        game_member: [],
        parent: ""
      };
      this.checkall = false;
      this.percent = null;
      this.commission = null;
      this.percent_ = null;
      this.commission_ = null;
    },

    async insert() {
      let ctx = this;
      this.form_member.game_member = [];
      this.provider.forEach(row => {
        if (row.status_ != undefined && row.status_ == 1) {
          this.form_member.game_member.push({
            provider_id: row.provider,
            percent: row.percent_,
            commission: row.commission_
          });
        }
      });
      this.$refs.form_member.validate(valid => {
        if (valid) {
          this.$q.loading.show({
            spinner: QSpinnerGears,
            spinnerColor: "primary",
            message: "Process Save"
          });
          this.form_member.parent = this.pid;
          this.$services.member
            .add(this.form_member)
            .then(function(data) {
              ctx.getdata();
              ctx.modal_add = false;
              ctx.$q.loading.hide();
              ctx.$services.success("Save Downline Success");
            })
            .catch(function(e) {
              ctx.$q.loading.hide();
              ctx.$services.error(e.response, ctx.$route);
            });
          ctx.$q.loading.hide();
        }
      });
    },

    async load(data) {
      let ctx = this;
      this.checkall = false;
      this.percent = null;
      this.commission = null;
      this.percent_ = null;
      this.commission_ = null;
      this.provider = [];
      this.roleChange(data.role);
      // this.get_subscribe(data.owner)
      let provider = await this.$services.subscribe.read(data.owner);
      this.form_member_edit = Object.assign({}, data);
      this.credit = data.credit;
      this.modal_edit = true;
      let subscribe = await this.$services.subscribe.read(data.id);
      provider.forEach(row => {
        let result = subscribe.filter(obj => {
          return obj.provider === row.provider;
        });
        if (result.length > 0) {
          row["percent_"] = result[0].percent;
          row["commission_"] = result[0].commission;
          row["id_"] = result[0].id;
          row["status_"] = true;
        }
      });
      this.provider = provider;
      // console.log('load:', this.provider)
      // this.percent = Math.max.apply(Math, this.provider.map(function(obj) { return obj.percent}))
      // this.commission = Math.max.apply(Math, this.provider.map(function(obj) { return obj.commission}))
      this.rowSelect();
    },

    async Update() {
      let ctx = this;
      this.form_member_edit.game_member = [];
      this.provider.forEach(row => {
        if (row.id_ != undefined) {
          this.form_member_edit.game_member.push({
            id: row.id_,
            provider_id: row.provider,
            percent: row.percent_,
            commission: row.commission_
          });
        } else if (row.status_ != undefined) {
          this.form_member_edit.game_member.push({
            provider_id: row.provider,
            percent: row.percent_,
            commission: row.commission_
          });
        }
      });
      this.$refs.form_member_edit.validate(valid => {
        if (valid) {
          this.$q.loading.show({
            spinner: QSpinnerGears,
            spinnerColor: "primary",
            message: "Process Save"
          });
          this.$services.member
            .update(this.form_member_edit, this.form_member_edit.id)
            .then(function(data) {
              ctx.getdata();
              ctx.modal_edit = false;
              ctx.$q.loading.hide();
              ctx.$services.success("Update Downline Success");
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$route);
            });
          ctx.$q.loading.hide();
        }
      });
    },

    backPage() {
      this.$router.push({ name: "company" });
    },

    roleChange(value) {
      let ctx = this;
      this.disable = false;
      this.role_options.filter(function(row) {
        if (row.value == value) {
          ctx.optionOwner(row.level);
          ctx.role = row.level;
          if (row.level == 4) {
            ctx.domain = true;
            ctx.rules_member["domain"] = [
              {
                required: true,
                message: "Please input domain",
                trigger: "blur"
              }
            ];
            ctx.rules_member_edit["domain"] = [
              {
                required: true,
                message: "Please input domain",
                trigger: "blur"
              }
            ];
          } else {
            ctx.domain = false;
            delete ctx.rules_member.domain;
            delete ctx.rules_member_edit.domain;
          }
        }
      });
    },

    async ownerChange(id) {
      // let ctx = this
      // let check = false
      this.get_subscribe(id);
      for (var i in this.data) {
        if (this.data[i].id == id) {
          this.pid = this.data[i].pid;
          break;
        }
      }
    },

    async check_credit(value) {
      try {
        return;
        let data = await this.$services.member.checkcredit({
          company: this.$route.params.id,
          owner: this.form_member.owner,
          member: null
        });
        if (value > data[0].credit_remain) {
          this.form_member.credit = data[0].credit_remain;
        }
      } catch (e) {
        this.$services.error(e.response, this.$route);
      }
    },

    async check_credit_update(value) {
      try {
        return;
        let data = await this.$services.member.checkcredit({
          company: this.$route.params.id,
          owner: this.form_member_edit.owner,
          member: this.form_member_edit.id
        });
        if (value > data[0].credit_remain) {
          this.form_member_edit.credit = data[0].credit_remain;
        }
      } catch (e) {
        this.$services.error(e.response, this.$route);
      }
    },

    ChangeStatus(row) {
      const prev = row.status == 0 ? 1 : 0;
      let ctx = this;
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want Change Status to Downline ${row.name} later, ok?`,
          ok: {
            push: true
          },
          cancel: {
            push: true,
            color: "negative"
          },
          persistent: true
        })
        .onOk(() => {
          this.$services.member
            .update(row, row.id)
            .then(function(data) {
              ctx.getdata();
              ctx.$services.success("Update Downline Success");
            })
            .catch(function(e) {
              row.status = prev;
              ctx.$services.error(e.response, ctx.$route);
            });
        })
        .onCancel(() => {
          row.status = prev;
          // console.log('>>>> Cancel')
        });
    },

    rowSelect(value) {
      if (
        this.provider.filter(row => {
          return row.status_ == 1;
        }).length == this.provider.length
      ) {
        this.checkall = true;
      } else {
        this.checkall = false;
      }
    },

    onSelection(value) {
      this.provider.forEach(row => {
        row.status_ = value;
      });
    },

    syncpercent(value) {
      this.provider.forEach(row => {
        row.percent_ = row.percent >= value ? value : row.percent;
      });
    },

    synccommison(value) {
      this.provider.forEach(row => {
        row.commission_ = row.commission > value ? value : row.commission;
      });
    },

    async get_owner() {
      let data = await this.$services.member.readByCompany({
        company: this.$route.params.id
      });
      data.forEach(row => {
        if (row.level != 6) {
          this.owner_filter.push({
            value: row.id,
            label: row.name,
            level: row.level
          });
        }
      });
    },

    open_deposit(row) {
      // console.log('row:', row)
      this.form_deposit = {
        member: row.id
      };
      this.modal_deposit = true;
    },

    async deposit() {
      let ctx = this;
      // console.log('deposit:', this.form_deposit)
      this.$refs.form_deposit.validate(valid => {
        if (valid) {
          this.$services.credit
            .deposit(this.form_deposit)
            .then(function(data) {
              ctx.modal_deposit = false;
              ctx.$services.success("Deposit Success");
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$route);
            });
        }
      });
      // console.log('deposit:', this.form)
    },

    open_withdraw(row) {
      this.form_withdraw = {
        member: row.id
      };
      this.modal_withdraw = true;
    },

    async withdraw() {
      let ctx = this;
      this.$refs.form_withdraw.validate(valid => {
        if (valid) {
          this.$services.credit
            .withdraw(this.form_withdraw)
            .then(function(data) {
              ctx.modal_withdraw = false;
              ctx.$services.success("Withdraw Success");
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$route);
            });
        }
      });
    },

    open_pass(row) {
      this.modal_reset = true;
      this.form_reset.member = row.id;
    },

    async reset_pass() {
      let ctx = this;
      this.$refs.form_reset.validate(valid => {
        if (valid) {
          this.$services.member
            .resetpasswordmember(this.form_reset, this.form_reset.member)
            .then(function(data) {
              ctx.$services.success("Reset Password Success");
              ctx.modal_reset = false;
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$router);
            });
        }
      });
    }
  },

  filters: {
    toUSD(value) {
      return `${value.toLocaleString()}`;
    }
  }
};
</script>

<style lang="sass" scoped>
.example-item

  width: 32%
</style>

<style type="text/css">
img {
  border: 0.5px solid #ddd;
  border-radius: 8px;
  padding: 5px;
  width: 100%;
}

.image {
  border: 0.5px solid #ddd;
  border-radius: 8px;
  padding: 5px;
  width: 50%;
}
</style>
